//+------------------------------------------------------------------+
//|                                                                  |
//|                      |
//|       PPZ                                         |
//|                               http://www.mql4.com/ru/users/Dserg |
//+------------------------------------------------------------------+
#property  copyright "Dserg, 2010"
#property  link      "http://www.mql4.com/ru/users/Dserg"

//---- indicator settings
#property  indicator_chart_window

double Fr0[10000];
int Ind0[10000];
int Ind1[10000];

// ,    
extern int timeFrame = 0;
extern int Nbars = 5000;
//    
extern int Nfirst = 0;
extern int Nhist =200;
static bool calculated;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings

   
   calculated = false;
   return(0);
  } 

int deinit()
  {
   ObjectDelete("V1");
   ObjectDelete("V2");
   ObjectDelete("V20");
   for(int t33 = 0; t33 < Nhist; t33++) ObjectDelete("line"+t33);
   Comment("");
   return(0);
  } 

int start()

  {
      if (calculated) return(0);
      //if (Nbars>500) { 
      //   Comment("Too much bars to calulate, try < 500");
      //   return(0);
      //}
      ArrayInitialize(Ind1,0);
     
      int counted_bars = IndicatorCounted(); 
 
      if (counted_bars < 0) return(-1); 
      if (counted_bars >= Bars) return(0);

      Comment("Calculating PPZ..");
      datetime t0 = TimeLocal();
      WindowRedraw();
      
      int loopbegin = Nbars+Nfirst;
      double Norm = iATR(NULL,timeFrame,Nbars,Nfirst);
 
      int t,i,j,k,l,n,m,imin,jmin,kmin,lmin,nmin,mmin,nmin1,mmin1,nmin2,mmin2,nmin3,mmin3,nmin4,mmin4,nmin5,mmin5,imin1,jmin1,kmin1,lmin1,imin2,jmin2,kmin2,lmin2,imin3,jmin3,kmin3,lmin3,imin4,jmin4,kmin4,lmin4,imin5,jmin5,kmin5,lmin5;
      double f0,f1,f2,f3,f4,f5,p0,s0,pmin,smin,pmin1,smin1,pmin2,smin2,pmin3,smin3,pmin4,smin4,pmin5,smin5;
      int Nmax;

      
      // ,   
      j=0;
      for(i = loopbegin; i > Nfirst; i--) {
        f0 = -1.0; 
        f0 = iFractals(NULL,timeFrame,MODE_UPPER,i);
        if (f0<=0.0 ) f0 = iFractals(NULL,timeFrame,MODE_LOWER,i);
        if (f0>0.0) {
         Fr0[j]=f0;
         Ind0[j]=i;
         j++;
        }
      }
     Nmax = j;
      
      
      

      double  max00=iHigh(NULL,timeFrame,iHighest(NULL,timeFrame,MODE_HIGH,Nbars,Nfirst));
      double  min00=iLow(NULL,timeFrame,iLowest(NULL,timeFrame,MODE_LOW,Nbars,Nfirst));
      //Alert(DoubleToStr(min00,Digits)+" "+DoubleToStr(min00,Digits));
      double step = (max00-min00)/Nhist;
      int Ntot = 0;
      
      
      for(t = 0; t < Nhist; t++) {
         double cur=min00 + t*step;
         double cur1=min00+ t*step+step;
         for(int t11 = 0; t11 < 10000; t11++) {
            if (Fr0[t11]>cur && Fr0[t11]<cur1) Ind1[t]++;   
            if (Fr0[t11]>0) Ntot++;   
         }   
            
      }
      for(t = 0; t < Nhist; t++) {
         int t22=50.0*Ind1[t]/1.0/Ind1[ArrayMaximum(Ind1)];
         if(!ObjectCreate("line"+t,OBJ_TREND,0,0,0)) {
           Comment("ERROR");
           return(0);
         }
         ObjectSet("line"+t, OBJPROP_RAY, false);
         ObjectSet("line"+t, OBJPROP_TIME1, Time[t22]); 
         ObjectSet("line"+t, OBJPROP_PRICE1, NormalizeDouble(min00+t*step,Digits));
         ObjectSet("line"+t, OBJPROP_TIME2, Time[0]);
         ObjectSet("line"+t, OBJPROP_PRICE2, NormalizeDouble(min00+t*step,Digits));
         ObjectSet("line"+t, OBJPROP_WIDTH, 1);
         ObjectSet("line"+t, OBJPROP_COLOR, Red);
         ObjectSetText("line"+t, ""); 
         ObjectSet("line"+t, OBJPROP_STYLE, STYLE_SOLID);        
      }
      
      if(!ObjectCreate("V1",OBJ_VLINE,0,iTime(NULL,timeFrame,Nbars+Nfirst),Open[0])) {
        Comment("ERROR");
        return(0);
      }
      if(!ObjectCreate("V2",OBJ_VLINE,0,iTime(NULL,timeFrame,Nfirst),Open[0])) {
        Comment("ERROR");
        return(0);
      }
      ObjectSet("V1",OBJPROP_COLOR,DarkKhaki);
      if(!ObjectCreate("V20",OBJ_VLINE,0,Time[50],Open[0])) {
        Comment("ERROR");
        return(0);
      }
      ObjectSet("V2",OBJPROP_COLOR,DarkKhaki);
      ObjectSet("V20",OBJPROP_COLOR,Red);
      
      calculated = true;
      datetime t1 = TimeLocal()-t0;
      Comment("Calculation of PPZ done \n Time " + t1 + " sec.");
      return(0);
  }
//+------------------------------------------------------------------+



